.gba
.open "zm.gba","Nightmare.gba",0x8000000

.definelabel NightmareID,0x6C
.definelabel NightmareBodyID,0x1
.definelabel NightmareBeamID,0x2
.definelabel NightmareChunkID,0x4

.definelabel UnlockDoors,0x300007B
.definelabel CurrentRoomEntries,0x30000BC
.definelabel BGPositions,0x30000E4
.definelabel SpriteData,0x30001AC
.definelabel CurrSpriteData,0x3000738
.definelabel ProjectileAccel,0x3001610
.definelabel CurrBossData,0x3001630   ;seems to house OAM, and position information for bosses. Also used for Yakuza
.definelabel PrevCollisionCheck,0x30007F1
.definelabel SpriteRNG,0x300083C
.definelabel CurrBossPattern,0x3000831
.definelabel CurrBossDirection,0x3000832
.definelabel GravityActive,0x3000833
.definelabel ProjectileData,0x3000A2C
.definelabel SamusData,0x30013D4
.definelabel BG1XPos,0x30013B8
.definelabel BG1YPos,0x30013BA
.definelabel SamusEquipment,0x3001530
.definelabel SamusPhysics,0x3001588

.definelabel PlaySound1,0x8002A18
.definelabel PlaySound3,0x8002A18; ?
.definelabel PlaySong,0x80039F4
.definelabel PlaySound5,0x8002A18; ?
.definelabel SpawnSecondarySprite,0x800E258
.definelabel CheckCollisionXY,0x800F688
.definelabel CheckEndOfSpriteAnimation,0x800FBC8
.definelabel SpriteDead,0x8011084
.definelabel VertScreenShake,0x8055344
.definelabel HoriScreenShake,0x8055378
.definelabel SetParticleEffect,0x80540EC
.definelabel EventFunctions,0x80608BC
.definelabel DivideSigned,0x808AC34
.definelabel DivideUnsigned,0x808ADE0
.definelabel BXR2,0x808AC00
.definelabel PrimarySpriteStats,0x82B0D68
.definelabel SecondarySpriteStats,0x82B1BE4
.definelabel SpriteAIPointers,0x875E8C0
.definelabel SSpriteAIPointers,0x875F1E8
.definelabel SpriteGfxPointers,0x875EBF8
.definelabel SpritePalPointers,0x875EEF0

.org 0x805D5E0
	.word 0x805D600  ;changes a branch table
	
	


.org 0x805D17C		;checks if nightmare is in room. Used in effect A and B. Vanilla effect A and B should still work otherwise
	ldr		r2,=CheckNightmareRoom + 1
	bl	BXR2
	cmp		r0,0h
	beq		@@Normal
	mov		r0,0xF0
	lsl		r0,r0,3h
	mov		r1,0xC
	b		@@Store
@@Normal:
	mov		r0,0xA0
	lsl		r3,r0,13h
	lsl		r0,r0,1h
	mov		r1,2h
@@Store:
	strh	r0,[r2,4h]
	strb	r1,[r2,6h]
	str		r3,[r2]
	b 		0x805D3CA
.pool

;.org 0x8304054    ; crocomire graphics

.org 0x8760D40			;freespace
WrapperR1:
	bx	r1
WrapperR2:
	bx	r2
WrapperR3:
	bx	r3
WrapperR4:
	bx	r4
WrapperR6:
	bx	r6
WrapperR7:
	bx	r7
.include "Nightmare\MainAI.asm"
.include "Nightmare\BodyParts.asm"
.include "Nightmare\Projectiles.asm"
.align
NightmareGfx:
.import "Nightmare\graphics.gfx.lz"
NightmarePal:
.align
.import "Nightmare\pal"
.include "Nightmare\Tables.asm"
.align
.include "Nightmare\OAM.asm"

; primary sprite stats
.org PrimarySpriteStats + NightmareID * 0x12
    .halfword 0x320   ; health
    .halfword 0x1E   ; damage
    .halfword 0x1A    ; weakness
    .halfword 0      ; no drop
    .halfword 0x200  ; small health
    .halfword 0x200  ; large health
    .halfword 0      ; missile
    .halfword 0      ; super missile
    .halfword 0      ; power bomb

;secondary sprites
.org SecondarySpriteStats + NightmareBodyID * 0x12
    .halfword 0x2C0      ; health
    .halfword 0      ; damage
    .halfword 6      ; weakness
    .halfword 0		 ; no drop
    .halfword 0x100	     ; small health
    .halfword 0x100      ; large health
    .halfword 0x100      ; missile
    .halfword 0x80      ; super missile
    .halfword 0x80      ; power bomb

.org SecondarySpriteStats + NightmareBeamID * 0x12
    .halfword 1    		; health
    .halfword 0x20      ; damage
    .halfword 0         ; weakness
    .halfword 0x400     ; no drop
    .halfword 0			; small health
    .halfword 0    		; large health
    .halfword 0    		; missile
    .halfword 0		    ; super missile
    .halfword 0      	; power bomb
	
.org SecondarySpriteStats + NightmareChunkID * 0x12
    .halfword 0    		; health
    .halfword 0      ; damage
    .halfword 0         ; weakness
    .halfword 0x400  ; no drop
    .halfword 0		 ; small health
    .halfword 0      ; large health
    .halfword 0      ; missile
    .halfword 0	     ; super missile
    .halfword 0      ; power bomb
	
	
; AI pointer
.org SpriteAIPointers + NightmareID * 4
    .word NightmareMain + 1
	
;Body Parts AI pointer
.org SSpriteAIPointers + NightmareBodyID * 4
    .word NightmarePartMain + 1
	
;Beam AI pointer
.org SSpriteAIPointers + NightmareBeamID * 4
    .word NightmareBeamMain + 1
	
;projectile AI pointer
.org SSpriteAIPointers + NightmareChunkID * 4
    .word NightmareChunkMain + 1
	
; graphics pointer
.org SpriteGfxPointers + (NightmareID - 0x10) * 4
    .word NightmareGfx

; palette pointer
.org SpritePalPointers + (NightmareID - 0x10) * 4
    .word NightmarePal


.close